#include amxmodx
#include cstrike
#include csx
#include engine
#include fakemeta
#include hamsandwich

#include <dhudmessage> // Amx Mod X 1.8.3
#include <colorchat> // Amx Mod X 1.8.3
#include <cvar_util> // Amx Mod X 1.8.3

/*
	АЛЯРМА: Опуская скролл вниз, вы окажетесь в пучине быдлокода, непонятных макросов, нового API Amx Mod X 1.8.3 и прочей еболы.
*/

#pragma semicolon 1

// [VARS & MACROSES]

new const PLUGIN[] = "Rush Mode";
new const VERSION[] = "1.1.8";
new const AUTHOR[] = "Sho0ter"; // Ты можешь в миг стать охуенным кодером, вписав сюда свой ник. Ой, то есть пидаром.

#define SHOW_COPYRIGHTS // :3

// Секции конфига
#define SECTION_INVALID 0
#define SECTION_WARMUP 1
#define SECTION_LIVE 2
#define SECTION_MAPS 3
#define SECTION_MODES 4
#define SECTION_WALLS 5

// Стадии игры
#define STATE_WAITING_FOR_PLAYERS_1ST 0 // Ожидание игроков перед голосованием за карту
#define STATE_VOTING_FOR_READY 1 // Подтверждения готовности
#define STATE_VOTING_FOR_MAP 2 // Голосование за карту
#define STATE_WAITING_FOR_PLAYERS_2ND 3 // Ожидание игроков перед голосованием за мод
#define STATE_VOTING_FOR_MODE 4 // Голосование за мод
#define STATE_GAME_IN_PROCESS 5 // Live
#define STATE_GAME_ENDED 6 // Игра окончена
#define STATE_EDITOR 99 // Редактор стен (дабы отключить остальные стадии)

// Различные задачи
// Все будут сняты при смене стадии игры
#define TASK_WAITING 33
#define TASK_VOTING_FOR_READY 66
#define TASK_VOTING_FOR_MAP 99
#define TASK_VOTING_FOR_MODE 133
#define TASK_PLAYERS_MENU 166
#define TASK_IN_PROCESS 199
#define TASK_EDITOR 233

// Разделы редактора стен
#define EDITOR_MAIN_MENU 0
#define EDITOR_WALL_PROP 1

// Свойства стен
#define EDITOR_PROP_ORIGIN 0
#define EDITOR_PROP_ANGLES 1
#define EDITOR_PROP_MINS 2
#define EDITOR_PROP_MAXS 3
#define EDITOR_PROP_SCALE 4
#define EDITOR_PROP_MODE 5
#define EDITOR_PROP_END 6

// Шаги изменения в редакторе
#define EDITOR_STEP_001 0
#define EDITOR_STEP_01 1
#define EDITOR_STEP_1 2
#define EDITOR_STEP_10 3
#define EDITOR_STEP_100 4
#define EDITOR_STEP_END 5

// Ебаное форматирование %.02f отображает 0.01 как 0.00
// Точность 146-го уровня :D
new const Float:EDITOR_STEPS[] = {
	0.01,
	0.1, 
	1.0, 
	10.0, 
	100.0
};

// Работа с битами
#define add_bit(%1,%2) (%1 |= (1 << (%2 - 1)))
#define is_bit(%1,%2) (%1 & (1 << (%2 - 1)))
#define remove_bit(%1,%2) (%1 &= ~(1 << (%2 - 1)))

// Структура свойст стены
// Используется только при парсинге из строки
// Хз, можно и без этого, но пусть будет
enum any:wall_struct {
	Float:ORIGIN_X,
	Float:ORIGIN_Y,
	Float:ORIGIN_Z,
	Float:ANGLES_X,
	Float:ANGLES_Y,
	Float:ANGLES_Z,
	Float:MINS_X,
	Float:MINS_Y,
	Float:MINS_Z,
	Float:MAXS_X,
	Float:MAXS_Y,
	Float:MAXS_Z,
	Float:SCALE
};

// Структура данных статистики
enum game_stats_struct {
	DEFENDER,
	RUSHER,
	ATTACKER
};

new game_stats[MAX_PLAYERS + 1][game_stats_struct];

// config_file по итогу будет хранить путь к конфиг-файлу карты
// Будем писать туда настройки стен из редактора
new config_file[192], parse_section;

// Битсуммны запрещенного оружия для каждой из команд
new restrictions[3];

// Сохраним тут текущую карту
new map_name[MAX_NAME_LENGTH];

// Количество подключенных игроков
new players_num;

// Будем хранить текущую команду игрока
// any во измежания варнинга из-за CsTeams
new any:players_team[MAX_PLAYERS + 1];

// Активный режим
// Используем в редактор стен и при загрузке самих стен для live
new current_mode[MAX_NAME_LENGTH];

// False, пока не умрет кто-то из теров
// Для определения RUSHER
new bool:first_blood;

// Количество убитых CT каждым из T в текущем раунде
new cts_killed[MAX_PLAYERS + 1];

// > 0 только если ожидается выбор напарника кем-то
// т.е. количество CT, которых должны пределить через меню
new need_cts_more;

// Количество побед CT подряд
// Обнуляется, если выигрывают T
new ct_win_streak;

// Количество сыгранных раундов в режиме LIVE
// Не номер раунда! А на 1 меньше по-сути
new round_count;

// Команда-победитель.
new any:winner_team;

// Конфиги кароч
new Array:config_live, Array:config_warmup, Array:config_maps, Array:config_modes, Trie:config_modes_translate, Array:config_walls, Trie:config_walls_by_modes, Array:active_walls;

// Квары, которые мы будем менять в процессе
new cvar_state_pointer, cvar_restartround_pointer;

// В этих же переменных будут храниться значения наших кваров
// Слава Amx Mod X 1.8.3
new cvar_state, cvar_ter_num, cvar_ct_num, cvar_vote_ready_timer, cvar_vote_map_timer, cvar_vote_map_count, cvar_vote_mode_timer, cvar_players_menu_timer, Float:cvar_respawn_delay, cvar_max_rounds, cvar_ct_win_streak, cvar_warmup_money, cvar_priority_flag[MAX_NAME_LENGTH], cvar_editor_flag[MAX_NAME_LENGTH], Float:cvar_freezetime, cvar_afk_time, cvar_afk_bomb_time;

// Битсуммы состояний игроков
// Вродь как и так понятно
new is_connected, is_alive, is_voted, is_unblock, is_transfered;

// Всякая херь для голосований
new vote_timer, vote_array_count[10], vote_array_item[10][64], vote_array_size, vote_count;

// Всякая херь для меню выбора напарника
new menu_players[MAX_PLAYERS + 1][MAX_PLAYERS], menu_size[MAX_PLAYERS + 1], menu_page[MAX_PLAYERS + 1], menu_timers[MAX_PLAYERS + 1], menu_counts[MAX_PLAYERS + 1];

// Всякая херь для редактора стен
new editor_menu, editor_enabled, editor_ent, editor_prop, editor_step, editor_think;

// Всякая херь для AFK-контроллера
new afk_origins[MAX_PLAYERS + 1][3], afk_time[MAX_PLAYERS + 1], afk_bomb_carrier, afk_origins_saved;

// [INITIALIZATION]

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	get_mapname(map_name, charsmax(map_name));
	
	// Кароч в Amx Mod X 1.8.3 есть волшебная переменная MaxClients
	// MaxClients = get_maxplayers();
	
	register_dictionary("rush.txt");
	
	// Ланг для карты
	// Раньше хз зачем грузил все .txt из подпаки rush (fixed)
	// По-идее можно даже set_fail_state ибо нехуй, все должно быть ЧОТКО 8)
	new lang_dir[128], lang_file[192];
	get_localinfo("amxx_datadir", lang_dir, charsmax(lang_dir));
	formatex(lang_file, charsmax(lang_file), "%s/lang/rush/%s.txt", lang_dir, map_name);
	if(file_exists(lang_file)) {
		formatex(lang_file, charsmax(lang_file), "rush/%s.txt", map_name);
		register_dictionary(lang_file);
	} else {
		log_amx("Can't open map lang file ^"%s^"", lang_file);
	}
	
	register_event("HLTV", "round_start", "a", "1=0", "2=0");
	register_event("SendAudio", "ter_win", "a", "2&%!MRAD_terwin");
	register_event("SendAudio", "ct_win", "a", "2&%!MRAD_ctwin");
	
	register_logevent("afk_bomb", 3, "1=triggered", "2=Spawned_With_The_Bomb", "2=Dropped_The_Bomb", "2=Got_The_Bomb", "2=Planted_The_Bomb");
	
	RegisterHam(Ham_Spawn, "player", "client_spawned", true);
	RegisterHam(Ham_Killed, "player", "client_killed", true);
	
	// Отброс оружия от стен
	register_touch("weaponbox", "rush_wall", "wall_touch");
	
	// Авто-выбор команды
	register_message(get_user_msgid("VGUIMenu"), "message_vgui_menu");
	register_message(get_user_msgid("ShowMenu"), "message_show_menu");
	
	// Отлов смены команды
	register_message(get_user_msgid("TeamInfo"), "message_team_info");
	
	// НУЖНО БОЛЬШЕ МЕНЮШЕЕЕЕЕК
	register_menucmd(register_menuid("voteready menu"), 1023, "ready_menu_action");
	register_menucmd(register_menuid("votemap menu"), 1023, "maps_menu_action");
	register_menucmd(register_menuid("votemode menu"), 1023, "mode_menu_action");
	register_menucmd(register_menuid("players menu"), 1023, "players_menu_action");
	
	register_menucmd(register_menuid("editor main menu"), 1023, "editor_main_menu_action");
	register_menucmd(register_menuid("editor prop menu"), 1023, "editor_prop_menu_action");
	
	// Ну тип вместо квара
	register_srvcmd("rush_ter_restrict", "cmd_ter_restrict");
	register_srvcmd("rush_ct_restrict", "cmd_ct_restrict");
	
	// Блочим команды смены в процессе игры
	register_clcmd("jointeam", "cmd_block");
	register_clcmd("joinclass", "cmd_block");
	
	// Вызов редактора
	register_clcmd("say /rush_editor", "cmd_editor");
	register_clcmd("say_team /rush_editor", "cmd_editor");
	register_clcmd("rush_editor", "cmd_editor");

	// Переделать под новое API кваров Amx Mod X 1.8.3 (хранить значения в переменных)
	// Done
	
	// Квар нужен, дабы сохранять состояние между сменами карты
	hook_cvar_change((cvar_state_pointer = create_cvar("rush_state", "0", (FCVAR_SERVER | FCVAR_EXTDLL | FCVAR_SPONLY))), "change_state");
	cvar_state = get_pcvar_num(cvar_state_pointer);
	
	bind_pcvar_num(create_cvar("rush_ter_num", "5", FCVAR_NONE, "", true, 1.0, true, 31.0), cvar_ter_num);
	bind_pcvar_num(create_cvar("rush_ct_num", "3", FCVAR_NONE, "", true, 1.0, true, 31.0), cvar_ct_num);
	bind_pcvar_num(create_cvar("rush_vote_ready_timer", "60", FCVAR_NONE, "", true, 1.0), cvar_vote_ready_timer);
	bind_pcvar_num(create_cvar("rush_vote_map_timer", "60", FCVAR_NONE, "", true, 1.0), cvar_vote_map_timer);
	bind_pcvar_num(create_cvar("rush_vote_map_count", "3", FCVAR_NONE, "", true, 2.0, true, 9.0), cvar_vote_map_count);
	bind_pcvar_num(create_cvar("rush_vote_mode_timer", "60", FCVAR_NONE, "", true, 1.0), cvar_vote_mode_timer);
	bind_pcvar_num(create_cvar("rush_players_menu_timer", "60", FCVAR_NONE, "", true, 1.0), cvar_players_menu_timer);
	bind_pcvar_num(create_cvar("rush_ct_win_streak", "7", FCVAR_NONE, "", true, 1.0), cvar_ct_win_streak);
	bind_pcvar_num(create_cvar("rush_max_rounds", "30", FCVAR_NONE, "", true, 1.0), cvar_max_rounds);
	bind_pcvar_float(create_cvar("rush_respawn_delay", "1.0", FCVAR_NONE, "", true, 0.1), cvar_respawn_delay);
	bind_pcvar_num(create_cvar("rush_afk_time", "60", FCVAR_NONE, "", true, 0.0), cvar_afk_time);
	bind_pcvar_num(create_cvar("rush_afk_bomb_time", "15", FCVAR_NONE, "", true, 0.0), cvar_afk_bomb_time);
	
	// В процессе теста оказалось, что деньги, которые дает mp_startmoney, быстро заканчиваются
	bind_pcvar_num(create_cvar("rush_warmup_money", "16000", FCVAR_NONE, "", true, 0.0, true, 16000.0), cvar_warmup_money);
	
	bind_pcvar_string(create_cvar("rush_priority_flag", "b"), cvar_priority_flag, charsmax(cvar_priority_flag));
	bind_pcvar_string(create_cvar("rush_editor_flag", "a"), cvar_editor_flag, charsmax(cvar_editor_flag));
	
	bind_pcvar_float(get_cvar_pointer("mp_freezetime"), cvar_freezetime);
	cvar_restartround_pointer = get_cvar_pointer("sv_restartround");
	
	// Массивы для конфигов
	config_live = ArrayCreate(512);
	config_warmup = ArrayCreate(512);
	config_maps = ArrayCreate(32);
	config_modes = ArrayCreate(32);
	config_modes_translate = TrieCreate();
	config_walls = ArrayCreate(192);
	config_walls_by_modes = TrieCreate();
	
	// Тут будем хранить энтити активных стен
	active_walls = ArrayCreate(1);
	
	// Грузим основной конфиг
	// Парсер требует Amx Mod X 1.8.3
	new configs_dir[128];
	get_localinfo("amxx_configsdir", configs_dir, charsmax(configs_dir));
	
	formatex(config_file, charsmax(config_file), "%s/rush.ini", configs_dir);
	if(!file_exists(config_file)) {
		set_fail_state("Config file ^"%s^" not found", config_file);
	}
	
	new INIParser:config_ini = INI_CreateParser();
	INI_SetReaders(config_ini, "config_keyvalue", "config_section");
	INI_ParseFile(config_ini, config_file);
	INI_DestroyParser(config_ini);
	
	// Грузим конфиг для карты
	// Парсер требует Amx Mod X 1.8.3
	formatex(config_file, charsmax(config_file), "%s/rush/%s.ini", configs_dir, map_name);
	if(!file_exists(config_file)) {
		set_fail_state("Map config file ^"%s^" not found", config_file);
	}
	
	config_ini = INI_CreateParser();
	INI_SetReaders(config_ini, "config_keyvalue", "config_section");
	INI_ParseFile(config_ini, config_file);
	INI_DestroyParser(config_ini);
	
	// Вывод в консоль
	#if defined SHOW_COPYRIGHTS
		server_print("%s v%s by %s initialized", PLUGIN, VERSION, AUTHOR);
	#endif
	
	// Нет никакого смысла продолжать без списка карт
	if(!ArraySize(config_maps)) {
		set_fail_state("Maplist is empty");
	}
	
	set_task(1.0, "afk_check", .flags="b");
}

// Какбэ спрайт стены
public plugin_precache() {
	precache_model("sprites/rush_wall.spr");
}

// [TEAM JOIN CONTOLLER]

// Вот тут определим смену команды игрока и запомним кто он у нас теперь
public message_team_info(msg_id, msg_dest, id) {
	static new_team[2];
	get_msg_arg_string(2, new_team, charsmax(new_team));
	
	switch(new_team[0]) {
		case('T'): {
			players_team[get_msg_arg_int(1)] = CS_TEAM_T;
		}
		
		case('C'): {
			players_team[get_msg_arg_int(1)] = CS_TEAM_CT;
		}
		
		default: {
			players_team[get_msg_arg_int(1)] = CS_TEAM_UNASSIGNED;
		}
	}
}

// Заблочим стандартные менюшки выбора команды
public message_show_menu(msg_id, msg_dest, id) {
	static menu_code[32];
	get_msg_arg_string(4, menu_code, charsmax(menu_code));

	if(containi(menu_code, "Team_Select") != -1) {
		new user_data[2];
		user_data[0] = msg_id;
		set_task(0.1, "task_do_choose_team", id, user_data, 2);
		return PLUGIN_HANDLED;
	}
	
	return PLUGIN_CONTINUE;
}

public message_vgui_menu(msg_id, msg_dest, id) {
	if(is_bit(is_connected, id) && get_msg_arg_int(1) == 2) {
		new user_data[2];
		user_data[0] = msg_id;
		set_task(0.1, "task_do_choose_team", id, user_data, 2);
		return PLUGIN_HANDLED;
	}
	
	return PLUGIN_CONTINUE;
}

// И назначим ему команду актоматически
public task_do_choose_team(const user_data[], id) {
	if(!is_bit(is_connected, id) || players_team[id] != CS_TEAM_UNASSIGNED) {
		return;
	}
	
	new message_id = user_data[0], ter_count = get_team_players_num(CS_TEAM_T, true);
	
	// Вродь как соблюдает баланс из конфига
	new new_team = (!ter_count || ((float(get_team_players_num(CS_TEAM_CT, true)) / float(ter_count)) >= (float(cvar_ct_num) / float(cvar_ter_num)))) ? 1 : 2;
	
	new message_block = get_msg_block(message_id);
	set_msg_block(message_id, BLOCK_SET);
	add_bit(is_unblock, id);
	
	static const string_nums[][] = {
		"0",
		"1",
		"2",
		"3",
		"4"
	};
	
	engclient_cmd(id, "jointeam", string_nums[new_team]);
	engclient_cmd(id, "joinclass", string_nums[(new_team == 1) ? 2 : 4]);
	
	remove_bit(is_unblock, id);
	set_msg_block(message_id, message_block);

	// Вообще норм место, чтобы отключить ссаные DHUD-ы помощи, которые сливаются с нашими
	set_user_info(id, "_ah", "0");
	client_cmd(id, "setinfo ^"_ah^" ^"0^"");
	
	if(cvar_state != STATE_GAME_IN_PROCESS) {
		set_task(1.0, "task_respawn", id);
	}
}

// Заблочим смену команды в процессе игры
public cmd_block(id) {
	if(!is_bit(is_unblock, id)) {
		return PLUGIN_HANDLED;
	}
	
	return PLUGIN_CONTINUE;
}

// [CONFIG CONTROLLER]

// Плагин загружен, игроков еще нет
// Грузим разминку тут
public plugin_cfg() {
	config_load(config_warmup);
	
	// Костыль
	new str[MAX_NAME_LENGTH];
	num_to_str(cvar_state, str, charsmax(str));
	change_state(cvar_state_pointer, str, str);
}

// Тут нам сообщают, что найдена новая секция конфига
public config_section(INIParser:handle, const section[]) {
	if(equal(section, "WARMUP")) {
		parse_section = SECTION_WARMUP;
	} else if(equal(section, "LIVE")) {
		parse_section = SECTION_LIVE;
	} else if(equal(section, "MAPS")) {
		parse_section = SECTION_MAPS;
	} else if(equal(section, "MODES")) {
		parse_section = SECTION_MODES;
	} else if(equal(section, "WALLS")) {
		parse_section = SECTION_WALLS;
	} else {
		parse_section = SECTION_INVALID;
		log_amx("Invalid config section ^"%s^"", section);
	}
	
	// Если этого не сделать, то парсинг прирывается
	// Както-то тупо, я хз
	return true;
}

// А здесь, что считана новая  пара ключ=значение
// Опытным путем установлено, что при отсутсвии включа, в него записыается значение
// Т.е. value может быть пустым, а вот key никогда
public config_keyvalue(INIParser:handle, key[], value[]) {
	remove_quotes(key);
	remove_quotes(value);

	switch(parse_section) {
		case(SECTION_WARMUP): {
			ArrayPushString(config_warmup, key);
		}
		
		case(SECTION_LIVE): {
			ArrayPushString(config_live, key);
		}

		case(SECTION_MAPS): {
			if(is_map_valid(key)) {
				ArrayPushString(config_maps, key);
			} else {
				log_amx("Map ^"%s^" is invalid", key);
			}
		}
		
		case(SECTION_MODES): {
			if(TrieKeyExists(config_modes_translate, key)) {
			
				// Ошибка не смертельная, но может указывать на ебланство настройщика
				// Так же может вызвать еболу со стенами, ы
				log_amx("Duplicate mode id ^"%s^"", key);
				
				return true;
			}
			
			ArrayPushString(config_modes, key);
			TrieSetString(config_modes_translate, key, value);
		}
		
		case(SECTION_WALLS): {
			if(!value[0]) {
				ArrayPushString(config_walls, key);
			} else {
				new Array:walls_array;
				
				if(TrieKeyExists(config_walls_by_modes, key)) {
					TrieGetCell(config_walls_by_modes, key, walls_array);
				} else {
					walls_array = ArrayCreate(192);
					TrieSetCell(config_walls_by_modes, key, walls_array);
				}

				ArrayPushString(walls_array, value);
			}
		}
	}
	
	// Если этого не сделать, то парсинг прирывается
	// Както-то тупо, я хз
	return true;
}

// Загрузка массива настроек через консоль сервера
stock config_load(Array:config_array) {
	new buffer[512], array_size = ArraySize(config_array);
	
	for(new i; i < array_size; i++) {
		ArrayGetString(config_array, i, buffer, charsmax(buffer));
		server_cmd("%s", buffer);
	}
	
	// Хз надо ли, но лишним не будет
	server_exec();
}

// [ROUND TRIGGERS]

// Начало раунда. Самое самое. Когда еще freezetime не прошел.
public round_start() {
	
	// Самое время обнулить количество убитых CT и разрешить определять рашера
	arrayset(cts_killed, 0, sizeof(cts_killed));
	first_blood = false;
	
	// Если игра закончена, то нужно еще разок вывести HUD со статистикой
	if(winner_team) {
		display_stats(true);
		
		winner_team = CS_TEAM_UNASSIGNED;
	}
	
	// В лайв-режиме выводим инфу о текущем номере раунде
	// Таск ибо может не вывести сразу, хз, не проверял
	if(cvar_state == STATE_GAME_IN_PROCESS && !need_cts_more) {
		set_task(0.1, "task_round_message", TASK_IN_PROCESS);
	}
}

// Собсно само сообщение о номере раунда
public task_round_message() {

	// Няшно исчезает по истечении заморозки
	set_dhudmessage(0, 255, 0, -1.0, 0.7, 2, 6.0, cvar_freezetime - 1.0, 0.01, 1.0);
	
	// Цикл, чтобы персонально для каждого подобрался язык
	for(new x = 1; x <= MaxClients; x++) {
		if(!is_bit(is_connected, x)) {
			continue;
		}
		
		show_dhudmessage(x, "%L", x, round_count ? "RUSH_GAME_IN_PROCESS" : "RUSH_GO_GO_GO", round_count + 1, cvar_max_rounds);
	}
}

// За взрыв бомбы даем бандиту 3 фрага
// Вот именно ради этой хуеты мы грузим целый модуль CSX
public bomb_explode(id) {
	cts_killed[id] += 3;
}

// Террористы выиграли раунд
public ter_win() {

	// Если не лайв, то ловить тут нечего
	if(cvar_state != STATE_GAME_IN_PROCESS || need_cts_more) {
		return;
	}
	
	// Собсно, CT просрали свое счастье
	ct_win_streak = 0;
	
	// Угу, проверка на количество раундов только тут, в остальных случаях даем CT возможность тащить
	if(++round_count >= cvar_max_rounds) {
		winner_team = CS_TEAM_T;
		set_pcvar_num(cvar_state_pointer, STATE_GAME_ENDED);
		return;
	}
	
	// Отложенно переводим лучших теров з CT, дабы не начали друг друга ебошить раньше времени
	set_task(4.0, "task_transfer", TASK_IN_PROCESS);
	
	// И, собсно, само сообщение о выигранном раунде
	// Цвет херово видно
	set_dhudmessage(255, 0, 0, -1.0, 0.7, 2, 6.0, 3.0, 0.01, 1.0);
	
	// Цикл, чтобы персонально для каждого подобрался язык
	for(new x = 1; x <= MaxClients; x++) {
		if(!is_bit(is_connected, x)) {
			continue;
		}
		
		show_dhudmessage(x, "%L", x, "RUSH_TER_WIN");
	}
}

// Спецназ победил
public ct_win() {

	// Если не лайв, то ловить тут нечего
	if(cvar_state != STATE_GAME_IN_PROCESS || need_cts_more) {
		return;
	}
	
	round_count++;

	// CT таки затащили должное количество раундов, GGWP
	if(++ct_win_streak >= cvar_ct_win_streak) {
		winner_team = CS_TEAM_CT;
		set_pcvar_num(cvar_state_pointer, STATE_GAME_ENDED);
		return;
	}

	// И, собсно, само сообщение о выигранном раунде
	set_dhudmessage(0, 128, 255, -1.0, 0.7, 2, 6.0, 3.0, 0.01, 1.0);
	
	// Цикл, чтобы персонально для каждого подобрался язык
	for(new x = 1; x <= MaxClients; x++) {
		if(!is_bit(is_connected, x)) {
			continue;
		}
		
		show_dhudmessage(x, "%L", x, "RUSH_CT_WIN", cvar_ct_win_streak - ct_win_streak);
	}
}

// [PLAYERS MENU]

// Менюшка выбора напарника
// Вызывается отдельно для каждого игрока
public task_show_players_menu(id) {
	id -= TASK_PLAYERS_MENU;
	
	if(!menu_timers[id]) {
		random_transfer(menu_counts[id]);
		need_cts_more -= menu_counts[id];
		menu_counts[id] = 0;
		
		remove_task(id + TASK_PLAYERS_MENU);
		
		if(!need_cts_more) {
			task_restartround();
		}
	} else {
		show_players_menu(id, menu_page[id]);
	}
	
	menu_timers[id]--;
}

public show_players_menu(id, page) {
	if(page < 0) {
		return;
	}
	
	menu_size[id] = 0;
	
	for(new pid = 1; pid <= MaxClients; pid++) {
		if(is_bit(is_connected, pid) && players_team[pid] == CS_TEAM_T) {
			menu_players[id][menu_size[id]++] = pid;
		}
	}
	
	new start = page * 8;
	new end = start + 8;
	
	if(start >= menu_size[id]) {
		show_players_menu(id, --menu_page[id]);
		return;
	}
	
	if(end > menu_size[id]) {
		end = menu_size[id];
	}
	
	new menu_text[512], keys, key, name[MAX_NAME_LENGTH];
	new len = formatex(menu_text, charsmax(menu_text), "%L", id, "RUSH_PLAYERS_MENU_HEADER");
	
	for(new i = start; i < end; i++) {
		keys |= (1 << key++);
		
		get_user_name(menu_players[id][i], name, charsmax(name));
		len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, "RUSH_PLAYERS_MENU_ITEM", key, name);
	}
	
	if(end != menu_size[id]) {
		keys |= (1 << 8);
	}

	if(page) {
		keys |= (1 << 9);
	}
	
	len += formatex(menu_text[len], charsmax(menu_text) - len, "%L%L%L", id, (end == menu_size[id]) ? "RUSH_MENU_MORE_DISABLED" : "RUSH_MENU_MORE", id, page ? "RUSH_MENU_BACK" : "RUSH_MENU_BACK_DISABLED", id, "RUSH_PLAYERS_MENU_FOOTER", menu_timers[id]);
	
	#if defined SHOW_COPYRIGHTS
		formatex(menu_text[len], charsmax(menu_text) - len, "^n^n\y%s v%s by %s", PLUGIN, VERSION, AUTHOR);
	#endif
	
	show_menu(id, keys, menu_text, (menu_timers[id] > 1) ? 2 : 1, "players menu");
}

public players_menu_action(id, key) {

	// Угу, тип уже не лайв
	if(cvar_state != STATE_GAME_IN_PROCESS || !need_cts_more) {
		return;
	}
	
	switch(key) {
		case(8): {
			show_players_menu(id, ++menu_page[id]);
		} case(9): {
			show_players_menu(id, --menu_page[id]);
		} default: {
			new pid = menu_players[id][(menu_page[id] * 8) + key];
			
			// Пока игрок слоупокает, многое может изменться
			if(!is_bit(is_connected, pid) || players_team[pid] != CS_TEAM_T) {
				show_players_menu(id, menu_page[id]);
				return;
			}
			
			new name1[MAX_NAME_LENGTH], name2[MAX_NAME_LENGTH];
			get_user_name(id, name1, charsmax(name1));
			get_user_name(pid, name2, charsmax(name2));
			
			// Цикл, чтобы персонально для каждого подобрался язык
			for(new x = 1; x <= MaxClients; x++) {
				if(!is_bit(is_connected, x)) {
					continue;
				}
				
				client_print_color(x, id, "%L", x, "RUSH_PLAYER_CHOOSED", name1, name2);
			}

			change_team(pid, CS_TEAM_CT, true);
			menu_counts[id]--;
			
			// Едем дальше
			if(!--need_cts_more) {
				remove_task(id + TASK_PLAYERS_MENU);
				task_restartround();
				return;
			}
			
			// Выбираем еще?
			if(menu_counts[id]) {
				show_players_menu(id, menu_page[id]);
			}
			
			// Обновляем менюшки всем
			for(new x = 1; x <= MaxClients; x++) {
				if(is_bit(is_connected, x) && x != id && menu_counts[x]) {
					show_players_menu(x, menu_page[x]);
				}
			}
		}
	}
}

// [PLAYER TRIGGERS]

// У нас новое мясо
public client_putinserver(id) {
	
	// Дискриминируем ботов и хлтв
	if(is_user_hltv(id) || is_user_bot(id)) {
		return;
	}
	
	add_bit(is_connected, id);
	players_num++;
	
	// Запускаем состояние, если мы в режиме ожидания и это мясо зрешало
	if((cvar_state == STATE_WAITING_FOR_PLAYERS_1ST || cvar_state == STATE_WAITING_FOR_PLAYERS_2ND) && players_num == (cvar_ct_num + cvar_ter_num)) {
		set_pcvar_num(cvar_state_pointer, (cvar_state == STATE_WAITING_FOR_PLAYERS_1ST) ? STATE_VOTING_FOR_READY : STATE_VOTING_FOR_MODE);
	}
}

// Мы будем по нему скучать...
public client_disconnect(id) {

	// Дискриминируем ботов и хлтв
	if(is_user_hltv(id) || is_user_bot(id)) {
		return;
	}
	
	// Стираем его с лица земли
	remove_bit(is_connected, id);
	remove_bit(is_alive, id);
	remove_bit(is_transfered, id);
	
	players_team[id] = CS_TEAM_UNASSIGNED;
	
	players_num--;
	
	arrayset(game_stats[id], 0, sizeof(game_stats[]));
	cts_killed[id] = 0;

	// Если он проголовал и ливнул, ска
	if(is_bit(is_voted, id)) {
		vote_count--;
		remove_bit(is_voted, id);
	}
	
	remove_task(id);
	
	// Ливнул в процессе выбора напарника
	if(menu_counts[id]) {
		menu_timers[id] = 0;
		task_show_players_menu(id + TASK_PLAYERS_MENU);
	}
	
	// Ливнул при запущенном редакторе стен
	if(editor_enabled == id) {
		cmd_editor(id);
	}
	
	// Ощищаем все, связанное с AFK
	afk_time[id] = 0;

	// Если у нас запущена голосовалка или он был последним CT, то переходим в режим ожидания и начинаем по-новой
	if(cvar_state == STATE_VOTING_FOR_MAP || cvar_state == STATE_VOTING_FOR_MODE || cvar_state == STATE_VOTING_FOR_READY || !get_team_players_num(CS_TEAM_CT)) {
		set_pcvar_num(cvar_state_pointer, (cvar_state >= STATE_WAITING_FOR_PLAYERS_2ND) ? STATE_WAITING_FOR_PLAYERS_2ND : STATE_WAITING_FOR_PLAYERS_1ST);
	}
}

// OWNED NAHOOI
public client_killed(id, killer) {
	remove_bit(is_alive, id);
	
	// Возрождаем в режиме разминки
	if(cvar_state != STATE_GAME_IN_PROCESS) {
		set_task(cvar_respawn_delay, "task_respawn", id);
	} else if(!need_cts_more && (1 <= killer <= MaxClients)) {
		// Рубрика ОЛОЛО: В первой версии создал переменную cts_killed а считать забыл
		if(players_team[id] == CS_TEAM_CT && players_team[killer] == CS_TEAM_T) {
			cts_killed[killer]++;
		}
		
		// Рашер?
		if(!first_blood && players_team[id] == CS_TEAM_T) {
			first_blood = true;
			game_stats[id][RUSHER]++;
		}
		
		// Запоминаем его заслуги
		game_stats[killer][(players_team[killer] == CS_TEAM_T) ? ATTACKER : DEFENDER]++;
	}
}

// Ку-ку, йопта
public client_spawned(id) {
	
	// Бывает фейковый вызов, например, при подключении
	// Хз пофиксили ли как-то
	if(!is_user_alive(id)) {
		return;
	}
	
	add_bit(is_alive, id);
	
	// Даем денюжку в режиме разминки
	if(cvar_state != STATE_GAME_IN_PROCESS && cvar_warmup_money) {
		cs_set_user_money(id, cvar_warmup_money, false);
	}
	
	remove_bit(afk_origins_saved, id);
	set_task(1.0, "afk_get_origins", id);
	
	return;
}

// [GAME STATE CONTROLLER]

// Отлов смены квара rush_state
public change_state(pointer, const old_value[], const new_value[]) {

	/*
	*	Все что было до меня, обнуляй.
	*	Жизнь море. Ща поныряем.
	*	Только ты давай, мне доверяй,
	*	И мы телепортом с тобой прямо в рай.
	*	Ты та о ком бьется в моей груди... 
	*	И я улетаю. 
	*	Вот такой вот мой тупой припев о любви.
	*	Тебе...
	*/
	
	// Обуняем все отложенные задачки
	remove_task(TASK_WAITING);
	remove_task(TASK_VOTING_FOR_READY);
	remove_task(TASK_VOTING_FOR_MAP);
	remove_task(TASK_VOTING_FOR_MODE);
	remove_task(TASK_IN_PROCESS);
	
	// Закрываем все менюшки
	for(new id = 1; id <= MaxClients; id++) {
		remove_task(id + TASK_PLAYERS_MENU);
		
		menu_page[id] = 0;
		menu_counts[id] = 0;
		menu_timers[id] = 0;
		
		if(is_bit(is_connected, id)) {
			show_menu(id, MENU_KEY_0, " ", 1, "voteready menu");
		}
	}
	
	// Давай по-новой, Миша
	need_cts_more = 0;
	first_blood = false;
	arrayset(cts_killed, 0, sizeof(cts_killed));
	ct_win_streak = 0;
	round_count = 0;
	is_voted = 0;
	vote_count = 0;
	vote_array_size = 0;
	arrayset(vote_array_count, 0, sizeof(vote_array_count));
	
	// Мы разрушим все преграды
	destroy_walls();
	
	// Что происходит теперь?
	switch((cvar_state = str_to_num(new_value))) {
	
		// Ожидание игроков, перед голосованием за карту
		case(STATE_WAITING_FOR_PLAYERS_1ST): {
			if(players_num == (cvar_ct_num + cvar_ter_num)) {
				set_pcvar_num(cvar_state_pointer, STATE_VOTING_FOR_READY);
			} else {
				task_waiting_message();
				set_task(1.0, "task_waiting_message", TASK_WAITING, .flags="b");
				
				set_dhudmessage(0, 255, 0, -1.0, 0.7, 2, 6.0, 4.0, 0.01, 1.0);
				
				// Цикл, чтобы персонально для каждого подобрался язык
				for(new x = 1; x <= MaxClients; x++) {
					if(!is_bit(is_connected, x)) {
						continue;
					}
					
					show_dhudmessage(x, "%L", x, "RUSH_WAITING");
				}
			}
		}
		
		// Подтверждаем готовность
		case(STATE_VOTING_FOR_READY): {
			vote_timer = cvar_vote_ready_timer;

			set_task(1.0, "task_vote_ready_menu", TASK_VOTING_FOR_READY, .flags="b");
			
			set_dhudmessage(0, 255, 0, -1.0, 0.7, 2, 6.0, 4.0, 0.01, 1.0);
			
			// Цикл, чтобы персонально для каждого подобрался язык
			for(new x = 1; x <= MaxClients; x++) {
				if(!is_bit(is_connected, x)) {
					continue;
				}
				
				show_dhudmessage(x, "%L", x, "RUSH_READY");
			}
		}
		
		case(STATE_VOTING_FOR_MAP): {
			vote_timer = cvar_vote_map_timer;

			new array_size = ArraySize(config_maps);
			
			// Отмечаем тут карты, которые уже нельзя нарандомить
			new Trie:maps_in_vote = TrieCreate();
			TrieSetCell(maps_in_vote, map_name, true);

			new new_random, buffer[MAX_NAME_LENGTH];
			
			// Намудрил пздц
			while(vote_array_size < cvar_vote_map_count) {
				new random_map = new_random = random_num(0, array_size - 1);
				
				// Нехватка break 2;
				new bool:global_break;

				while(!global_break) {
					ArrayGetString(config_maps, new_random, buffer, charsmax(buffer));
					
					// Карту можно добавить?
					if(!TrieKeyExists(maps_in_vote, buffer)) {
						break;
					}
					
					// Дошли до конца массива карт. Начинаем сначала, пока не дойдем до начальной точки или доступной карты.
					if(++new_random == array_size) {
						new_random = 0;
					}
					
					// Больше нет доступных карт?
					if(array_size == 1 || new_random == random_map) {
						global_break = true;
						break;
					}
				}
				
				// break 2;
				if(global_break) {
					break;
				}
				
				TrieSetCell(maps_in_vote, buffer, true);
				copy(vote_array_item[vote_array_size++], charsmax(vote_array_item[]), buffer);
			}
			
			TrieDestroy(maps_in_vote);

			set_task(1.0, "task_vote_map_menu", TASK_VOTING_FOR_MAP, .flags="b");
			
			set_dhudmessage(0, 255, 0, -1.0, 0.7, 2, 6.0, 4.0, 0.01, 1.0);
			
			// Цикл, чтобы персонально для каждого подобрался язык
			for(new x = 1; x <= MaxClients; x++) {
				if(!is_bit(is_connected, x)) {
					continue;
				}
				
				show_dhudmessage(x, "%L", x, "RUSH_VOTEMAP");
			}
		}
		
		// Дублируем код, или кородко о том, как делать не нужно
		case(STATE_WAITING_FOR_PLAYERS_2ND): {
			if(players_num == (cvar_ct_num + cvar_ter_num)) {
				set_pcvar_num(cvar_state_pointer, STATE_VOTING_FOR_MODE);
			} else {
				set_task(1.0, "task_waiting_message", TASK_WAITING, .flags="b");
				
				set_dhudmessage(0, 255, 0, -1.0, 0.7, 2, 6.0, 4.0, 0.01, 1.0);
				
				// Цикл, чтобы персонально для каждого подобрался язык
				for(new x = 1; x <= MaxClients; x++) {
					if(!is_bit(is_connected, x)) {
						continue;
					}
					
					show_dhudmessage(x, "%L", x, "RUSH_WAITING");
				}
			}
		}
		
		case(STATE_VOTING_FOR_MODE): {
			vote_timer = cvar_vote_mode_timer;

			// Ну типа если режимов больше 9, то я хз
			new modes_array_size = min(9, ArraySize(config_modes)), buffer[MAX_NAME_LENGTH];

			for(vote_array_size = 0; vote_array_size < modes_array_size; vote_array_size++) {
				ArrayGetString(config_modes, vote_array_size, buffer, charsmax(buffer));
				TrieGetString(config_modes_translate, buffer, vote_array_item[vote_array_size], charsmax(vote_array_item[]));
			}
			set_task(1.0, "task_vote_mode_menu", TASK_VOTING_FOR_MODE, .flags="b");
			
			set_dhudmessage(0, 255, 0, -1.0, 0.7, 2, 6.0, 4.0, 0.01, 1.0);
			
			// Цикл, чтобы персонально для каждого подобрался язык
			for(new x = 1; x <= MaxClients; x++) {
				if(!is_bit(is_connected, x)) {
					continue;
				}
					
				show_dhudmessage(x, "%L", x, "RUSH_MODE");
			}
		}
		
		case(STATE_GAME_IN_PROCESS): {
		
			// swap = true
			random_transfer(cvar_ct_num, true);

			// Загружем LIVE кофиг
			config_load(config_live);
			
			// Ставим стенки
			spawn_walls();

			// Рестарт и поехали
			task_restartround();
		}
		
		case(STATE_GAME_ENDED): {
			
			// У нас есть победитель!
			if(winner_team == CS_TEAM_T) {
				set_dhudmessage(255, 0, 0, -1.0, 0.7, 2, 6.0, 4.0, 0.01, 1.0);
			} else {
				set_dhudmessage(0, 128, 255, -1.0, 0.7, 2, 6.0, 4.0, 0.01, 1.0);
			}
			
			// Цикл, чтобы персонально для каждого подобрался язык
			for(new x = 1; x <= MaxClients; x++) {
				if(!is_bit(is_connected, x)) {
					continue;
				}
					
				show_dhudmessage(x, "%L", x, (winner_team == CS_TEAM_T) ? "RUSH_WIN_TER" : "RUSH_WIN_CT");
			}
			
			// Убираем стенки
			display_stats();
			
			// Вармап + выбор карты через 4.0 сек
			set_task(4.0, "task_game_ended");
		}
		
		case(STATE_EDITOR): {
			// Собсно делать тут дейстительно нехуй, главное, чтобы остальные секции тихо сидели
		}
		
		default: {
			// Кто-то любит менять квар через консоль на хуй-пойми что
			log_amx("Invalid state %d", cvar_state);
		}
	}
}

// [VOTE FOR READY]

// Магия подтверждения готовности
public task_vote_ready_menu() {
	if(vote_timer) {
		show_vote_ready_menu();
		vote_timer--;
	} else {
		remove_task(TASK_VOTING_FOR_READY);
		kick_afk_players();
	}
}

stock show_vote_ready_menu() {
	#if defined SHOW_COPYRIGHTS
		new menu_text[512], len;
	#else
		new menu_text[512];
	#endif
	
	for(new id = 1; id <= MaxClients; id++) {
		if(!is_bit(is_connected, id)) {
			continue;
		}
		
		#if defined SHOW_COPYRIGHTS
			len = formatex(menu_text, charsmax(menu_text), "%L", id, is_bit(is_voted, id) ? "RUSH_READY_MENU_VOTED" : "RUSH_READY_MENU", vote_count, players_num, vote_timer);
			formatex(menu_text[len], charsmax(menu_text) - len, "^n^n\y%s v%s by %s", PLUGIN, VERSION, AUTHOR);
		#else
			formatex(menu_text, charsmax(menu_text), "%L", id, is_bit(is_voted, id) ? "RUSH_READY_MENU_VOTED" : "RUSH_READY_MENU", vote_count, players_num, vote_timer);
		#endif
		
		show_menu(id, is_bit(is_voted, id) ? MENU_KEY_0 : MENU_KEY_1, menu_text, (vote_timer <= 1) ? 1 : 2, "voteready menu");
	}	
}

// Кнопошку нажали
public ready_menu_action(id, key) {
	// Уже подтвердил или уже не голосуем? Пока
	if(is_bit(is_voted, id) || cvar_state != STATE_VOTING_FOR_READY) {
		return;
	}
	
	add_bit(is_voted, id);
	vote_count++;
	
	new name[MAX_NAME_LENGTH];
	get_user_name(id, name, charsmax(name));
	
	// Цикл, чтобы персонально для каждого подобрался язык
	for(new x = 1; x <= MaxClients; x++) {
		if(!is_bit(is_connected, x)) {
			continue;
		}
		
		client_print_color(x, id, "%L", x, "RUSH_READY_ACCEPT", name);
	}
	
	// Все проголосовали?
	if(vote_count == players_num) {
		set_pcvar_num(cvar_state_pointer, STATE_VOTING_FOR_MAP);
	} else {
		// Обновляем менюшки всем
		show_vote_ready_menu();
	}
}

// [VOTE FOR MAP]

// Магия голосования за карту
public task_vote_map_menu() {
	if(vote_timer) {
		show_vote_map_menu();
		vote_timer--;
	} else {
		remove_task(TASK_VOTING_FOR_MAP);
		kick_afk_players();
	}
}

stock show_vote_map_menu() {
	new menu_text[512], keys, len;
	
	for(new id = 1; id <= MaxClients; id++) {
		if(!is_bit(is_connected, id)) {
			continue;
		}
		
		len = formatex(menu_text, charsmax(menu_text), "%L", id, "RUSH_VOTEMAP_MENU_HEADER");

		for(new i; i < vote_array_size; i++) {
			if(!is_bit(is_voted, id)) {
				keys |= (1 << i);
			}
						
			len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, is_bit(is_voted, id) ? "RUSH_VOTEMAP_MENU_VOTED" : "RUSH_VOTEMAP_MENU_NORMAL", i + 1, vote_array_item[i], vote_array_count[i]);
		}
					
		len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, "RUSH_VOTEMAP_MENU_FOOTER", vote_count, players_num, vote_timer);
				
		#if defined SHOW_COPYRIGHTS
			formatex(menu_text[len], charsmax(menu_text) - len, "^n^n\y%s v%s by %s", PLUGIN, VERSION, AUTHOR);
		#endif
				
		show_menu(id, keys ? keys : MENU_KEY_0, menu_text, (vote_timer <= 1) ? 1 : 2, "votemap menu");
	}
}

// Кнопошку нажали
public maps_menu_action(id, key) {
	// Уже проголосовал или голосование окончено? Пока
	if(is_bit(is_voted, id) || cvar_state != STATE_VOTING_FOR_MAP) {
		return;
	}
	
	add_bit(is_voted, id);
	vote_count++;
	
	new name[MAX_NAME_LENGTH];
	get_user_name(id, name, charsmax(name));
	
	// Цикл, чтобы персонально для каждого подобрался язык
	for(new x = 1; x <= MaxClients; x++) {
		if(!is_bit(is_connected, x)) {
			continue;
		}
		
		client_print_color(x, id, "%L", x, "RUSH_MAPS_ACCEPT", name, vote_array_item[key]);
	}
	
	vote_array_count[key]++;
	
	// Все проголосовали?
	if(vote_count == players_num) {
		remove_task(TASK_VOTING_FOR_MAP);
		
		// Определяем победителя
		new winner, max_count;
		for(new i; i < vote_array_size; i++) {
			if(max_count < vote_array_count[i]) {
				max_count = vote_array_count[i];
				winner = i;
			}
		}
		
		set_dhudmessage(0, 255, 0, -1.0, 0.7, 2, 6.0, 4.0, 0.01, 1.0);
		
		// Цикл, чтобы персонально для каждого подобрался язык
		for(new x = 1; x <= MaxClients; x++) {
			if(!is_bit(is_connected, x)) {
				continue;
			}
			
			show_dhudmessage(x, "%L", x, "RUSH_CHANGELEVEL", vote_array_item[winner]);
		}
		
		// Меняем карту через 5 сек., дабы сообщение немного повисело
		set_task(5.0, "task_changelevel", TASK_VOTING_FOR_MAP, vote_array_item[winner], sizeof(vote_array_item[]));
	} else {
		// Обновляем всем менюшки
		show_vote_map_menu();
	}
}

// Меняем карту тут
public task_changelevel(const new_map[]) {
	set_pcvar_num(cvar_state_pointer, STATE_WAITING_FOR_PLAYERS_2ND);
	server_cmd("changelevel %s", new_map);
}

// [VOTE FOR MODE]

// Магия голосования за мод
public task_vote_mode_menu() {
	if(vote_timer) {
		show_vote_mode_menu();
		vote_timer--;
	} else {
		remove_task(TASK_VOTING_FOR_MODE);
		kick_afk_players();
	}
}

public show_vote_mode_menu() {
	new menu_text[512], keys, len;
	
	for(new id = 1; id <= MaxClients; id++) {
		if(!is_bit(is_connected, id)) {
			continue;
		}
		
		len = formatex(menu_text, charsmax(menu_text), "%L", id, "RUSH_VOTEMODE_MENU_HEADER");
				
		for(new i; i < vote_array_size; i++) {
			if(!is_bit(is_voted, id)) {
				keys |= (1 << i);
			}

			len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, is_bit(is_voted, id) ? "RUSH_VOTEMODE_MENU_VOTED" : "RUSH_VOTEMODE_MENU_NORMAL", i + 1, id, vote_array_item[i], vote_array_count[i]);
		}
					
		len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, "RUSH_VOTEMODE_MENU_FOOTER", vote_count, players_num, vote_timer);
				
		#if defined SHOW_COPYRIGHTS
			formatex(menu_text[len], charsmax(menu_text) - len, "^n^n\y%s v%s by %s", PLUGIN, VERSION, AUTHOR);
		#endif
				
		show_menu(id, keys ? keys : MENU_KEY_0, menu_text, (vote_timer <= 1) ? 1 : 2, "votemode menu");
	}
}

// Кнопошку нажали
public mode_menu_action(id, key) {
	// Уже проголосовал или голосование завершено? Пока
	if(is_bit(is_voted, id) || cvar_state != STATE_VOTING_FOR_MODE) {
		return;
	}
	
	add_bit(is_voted, id);
	vote_count++;
	
	new name[MAX_NAME_LENGTH];
	get_user_name(id, name, charsmax(name));
	
	// Цикл, чтобы персонально для каждого подобрался язык
	for(new x = 1; x <= MaxClients; x++) {
		if(!is_bit(is_connected, x)) {
			continue;
		}
		
		client_print_color(x, id, "%L", x, "RUSH_MODE_ACCEPT", name, x, vote_array_item[key]);
	}
	
	vote_array_count[key]++;
	
	// Все проголосовали?
	if(vote_count == players_num) {
		remove_task(TASK_VOTING_FOR_MODE);
		
		// Определяем пробедителя
		new winner, max_count;
		for(new i; i < vote_array_size; i++) {
			if(max_count < vote_array_count[i]) {
				max_count = vote_array_count[i];
				winner = i;
			}
		}
		
		set_dhudmessage(0, 255, 0, -1.0, 0.7, 2, 6.0, 4.0, 0.01, 1.0);
		
		// Цикл, чтобы персонально для каждого подобрался язык
		for(new x = 1; x <= MaxClients; x++) {
			if(!is_bit(is_connected, x)) {
				continue;
			}
			
			show_dhudmessage(x, "%L", x, "RUSH_LIVE", LANG_PLAYER, vote_array_item[winner]);
		}
		
		ArrayGetString(config_modes, winner, current_mode, charsmax(current_mode));

		// Лайв через 5 сек., дабы сообщение немного повисело
		set_task(5.0, "task_live");
	} else {
		// Обновляем всем менюшки
		show_vote_mode_menu();
	}
}

// [CUSTOM TASKS]

// Возрождение Warmup-а
public task_respawn(id) {
	if(is_bit(is_connected, id) && !is_bit(is_alive, id) && cvar_state != STATE_GAME_IN_PROCESS) {
		ExecuteHamB(Ham_CS_RoundRespawn, id);
	}
}

// Ожидание игроков: %d из %d
public task_waiting_message() {
	set_dhudmessage(255, 255, 255, -1.0, 0.0, 0, 0.0, 1.1, 0.0, 0.0);
	
	// Цикл, чтобы персонально для каждого подобрался язык
	for(new x = 1; x <= MaxClients; x++) {
		if(!is_bit(is_connected, x)) {
			continue;
		}
		
		show_dhudmessage(x, "%L", x, "RUSH_WAITING_FOR_PLAYERS", players_num, cvar_ter_num + cvar_ct_num);
	}
}

// Рестартик
public task_restartround() {
	// Тут норм обнулять
	is_transfered = 0;
	
	set_pcvar_num(cvar_restartround_pointer, 1);
}

// Запуска LIVE
public task_live() {
	set_pcvar_num(cvar_state_pointer, STATE_GAME_IN_PROCESS);
}

// Загрузка вармапа и голосования за карту после окончания игры
public task_game_ended() {
	config_load(config_warmup);
	
	task_restartround();
	
	set_task(5.0, "task_game_ended_post");
}

public task_game_ended_post() {
	set_pcvar_num(cvar_state_pointer, (players_num == (cvar_ter_num + cvar_ct_num)) ? STATE_VOTING_FOR_MAP : STATE_WAITING_FOR_PLAYERS_1ST);
}

// Перевод игроков после выигрыша террористов
// Рубрика кривые руки: фиксил это место уже хз сколько раз. Бесконечные циклы и прочая хуйня.
public task_transfer() {
	new need_cts = cvar_ct_num;
	
	// Переводим топовых теров з CT
	for(new id = 1; id <= MaxClients && need_cts; id++) {
		if(is_bit(is_connected, id) && players_team[id] == CS_TEAM_T && cts_killed[id]) {
			change_team(id, CS_TEAM_CT);
			need_cts--;
			add_bit(is_transfered, id);
		}
	}
	
	// Затем переводим бывших CT за теров
	for(new id = 1; id <= MaxClients; id++) {
		if(is_bit(is_connected, id) && !is_bit(is_transfered, id) && players_team[id] == CS_TEAM_CT) {
			change_team(id, CS_TEAM_T);
			add_bit(is_transfered, id);
		}
	}
	
	// Далее смотрим нужно ли кому открыть менюшку выбора напарников
	for(new id = 1; id <= MaxClients && need_cts; id++) {
		if(is_bit(is_connected, id) && is_bit(is_transfered, id) && cts_killed[id] > 1) {
			new new_count = min(need_cts, cts_killed[id] - 1);
			need_cts -= new_count;
			need_cts_more += new_count;
			menu_counts[id] = new_count;
			menu_timers[id] = cvar_players_menu_timer;
			menu_page[id] = 0;
			
			task_show_players_menu(id + TASK_PLAYERS_MENU);
			set_task(1.0, "task_show_players_menu", id + TASK_PLAYERS_MENU, .flags="b");
			
			new name[MAX_NAME_LENGTH];
			get_user_name(id, name, charsmax(name));
			
			// Цикл, чтобы персонально для каждого подобрался язык
			for(new x = 1; x <= MaxClients; x++) {
				if(!is_bit(is_connected, x)) {
					continue;
				}
				
				client_print_color(x, id, "%L", x, "RUSH_PLAYERS_MENU_NOTICE", name);
			}
		}
	}
	
	// Нужно еще дорандомить (кстати, такого быть не должно)
	if(need_cts) {
		random_transfer(need_cts);
	}
	
	// Никто не выбирает напарника? Продолжаем
	if(!need_cts_more) {
		task_restartround();
	}
}

// [STOCKS]

// Кикаем слоупоков
stock kick_afk_players() {
	for(new id = 1; id <= MaxClients; id++) {
		if(is_bit(is_connected, id) && !is_bit(is_voted, id)) {
			svc_disconnect(id, "%L", id, "RUSH_AFK_KICK_REASON");
			
			new name[MAX_NAME_LENGTH];
			get_user_name(id, name, charsmax(name));
			
			// Цикл, чтобы персонально для каждого подобрался язык
			for(new x = 1; x <= MaxClients; x++) {
				if(!is_bit(is_connected, x)) {
					continue;
				}
				
				client_print_color(x, id, "%L", x, "RUSH_AFK_KICK_MESSAGE", name);
			}
		}
	}
}

// Взял из другого своего плагина
stock svc_disconnect(id, const input[], any:...) {
	if(!is_bit(is_connected, id) && !is_user_connecting(id)) {
		return;
	}
	
	new formatted_message[192];
	vformat(formatted_message, charsmax(formatted_message), input, 3);

	message_begin(MSG_ONE, SVC_DISCONNECT, .player = id);
	write_string(formatted_message);
	message_end();
	
	new user_data[194];
	user_data[0] = id;
	user_data[1] = get_user_userid(id);
	copy(user_data[2], 191, formatted_message);
	
	set_task(1.0, "__svc_disconnect__", id, user_data, sizeof(user_data));
}

public __svc_disconnect__(const __user_data__[]) {
	static id;
	id = __user_data__[0];
	
	if((!is_bit(is_connected, id) && !is_user_connecting(id)) || __user_data__[1] != get_user_userid(id)) {
		return;
	}
	
	server_cmd("kick #%d  %s", __user_data__[1], __user_data__[2]);
}

// Возвращает количество игроков в команде
// count_pending = с учетом перемещения как напарника
stock get_team_players_num(any:team, bool:count_pending = false, bool:only_alive = false) {
	new count;
	
	for(new id = 1; id <= MaxClients; id++) {
		if(is_bit(is_connected, id) && (!only_alive || is_bit(is_alive, id)) && players_team[id] == team) {
			count++;
		}
	}
	
	if(count_pending) {
		if(team == CS_TEAM_T) {
			count -= need_cts_more;
		} else {
			count += need_cts_more;
		}
	}
	
	return count;
}

// Меняет команду
stock change_team(id, any:team, bool:silent = false) {
	cs_set_user_team(id, team , (team == CS_TEAM_T) ? CS_T_LEET : CS_CT_GIGN);
	
	players_team[id] = team;
	
	// Флуд-флуд-флуд. Поэтому пишем только о переведенных за CT.
	if(team == CS_TEAM_CT && !silent) {
		new name[MAX_NAME_LENGTH];
		get_user_name(id, name, charsmax(name));
		
		// Цикл, чтобы персонально для каждого подобрался язык
		for(new x = 1; x <= MaxClients; x++) {
			if(!is_bit(is_connected, x)) {
				continue;
			}
			
			client_print_color(x, print_team_blue, "%L", x, "RUSH_TRANSFERED_CT", name);
		}
	}
}

// АПОГЕЙ КРИВЫХ РУК
// ПИЗДА СКОЛЬКО В ЭТОЙ ФУНКЦИИ БЫЛО БАГОВ
// Ну а так то рандомно перемещает гусей за CT
// swap = старых CT сделать бандитами
stock random_transfer(count, bool:swap = false) {
	new players[32], num;
	
	for(new id = 1; id <= MaxClients; id++) {
		if(is_bit(is_connected, id) && !is_bit(is_transfered, id) && (swap || players_team[id] == CS_TEAM_T)) {
			players[num++] = id;
		}
	}
	
	if(!num) {
		// Хз, такое бывает?
		return;
	} else if(num <= count) {
		// Случай не менее странный
		for(new i; i < num; i++) {
			change_team(players[i], CS_TEAM_CT);
			add_bit(is_transfered, players[i]);
		}
	} else {
		new new_random, priority_flag, bool:ignore_flag;
		priority_flag = read_flags(cvar_priority_flag);
			
		for(new transfer_count; transfer_count < count; transfer_count++) {
			// Колдуем
			new random_id = new_random = random_num(0, num - 1);

			while(transfer_count < count) {
				// Подгодит для перемещения?
				if(!is_bit(is_transfered, players[new_random]) && (ignore_flag || (get_user_flags(players[new_random]) & priority_flag))) {
					break;
				}
				
				// Лень писать, смотри создание массива голосования за карту
				if(++new_random == num) {
					new_random = 0;
				}
				
				// Всех с флагом переместили
				if(new_random == random_id) {
					ignore_flag = true;
					continue;
				}
			}

			change_team(players[new_random], CS_TEAM_CT);
			add_bit(is_transfered, players[new_random]);
		}
	}
	
	// Всех старых CT переводим
	if(swap) {
		for(new id = 1; id <= MaxClients; id++) {
			if(is_bit(is_connected, id) && !is_bit(is_transfered, id) && players_team[id] == CS_TEAM_CT) {
				change_team(id, CS_TEAM_T);
			}
		}
	}
}

// Выводит статистику по окончания игры
// reset = обнуляет после отображения
stock display_stats(bool:reset = false) {
	new stats_message[512], len, top_defender, top_defender_count, top_rusher, top_rusher_count, top_attacker, top_attacker_count;
	
	// Кто же у нас лучший?
	for(new id = 1; id <= MaxClients; id++) {
		if(!is_bit(is_connected, id)) {
			continue;
		}
		
		if(game_stats[id][DEFENDER] > top_defender_count) {
			top_defender = id;
			top_defender_count = game_stats[id][DEFENDER];
		}
		
		if(game_stats[id][RUSHER] > top_rusher_count) {
			top_rusher = id;
			top_rusher_count = game_stats[id][RUSHER];
		}
		
		if(game_stats[id][ATTACKER] > top_attacker_count) {
			top_attacker = id;
			top_attacker_count = game_stats[id][ATTACKER];
		}
	}
	
	new defender_name[MAX_NAME_LENGTH], rusher_name[MAX_NAME_LENGTH], attacker_name[MAX_NAME_LENGTH];
	get_user_name(top_defender, defender_name, charsmax(defender_name));
	get_user_name(top_rusher, rusher_name, charsmax(rusher_name));
	get_user_name(top_attacker, attacker_name, charsmax(attacker_name));
	
	set_hudmessage(192, 192, 192, 0.65, 0.2, 0, 6.0, 15.0, reset ? 0.0 : 1.0, 1.0);
	
	// Цикл, чтобы персонально для каждого подобрался язык
	for(new id = 1; id <= MaxClients; id++) {
		if(!is_bit(is_connected, id)) {
			continue;
		}
	
		len = formatex(stats_message, charsmax(stats_message), "%L", id, "RUSH_STATS_DEFENDER", defender_name, top_defender_count);
		len += formatex(stats_message[len], charsmax(stats_message) - len, "^n^n%L", id, "RUSH_STATS_RUSHER", rusher_name, top_rusher_count);
		formatex(stats_message[len], charsmax(stats_message) - len, "^n^n%L", id, "RUSH_STATS_ATTACKER", attacker_name, top_attacker_count);

		show_hudmessage(id, "%s", stats_message);
	}
	
	if(reset) {
		for(new id = 1; id <= MaxClients; id++) {
			arrayset(game_stats[id], 0, sizeof(game_stats[]));
		}
	}
}

// [WALLS EDITOR]

// Ну тут пиздец намудрил
// Часть кода взята с Mode 2x2
// s1lent няшка :3

// Собсно сама команда
public cmd_editor(id) {
	// Нет доступа? Пока
	if(!(get_user_flags(id) & read_flags(cvar_editor_flag))) {
		return PLUGIN_CONTINUE;
	}
	
	// Уже запущен редактор?
	if(editor_enabled) {
		// Другой админ уже редактирует? Пока
		if(editor_enabled != id) {
			client_print_color(id, id, "%L", id, "RUSH_EDITOR_ANOTHER_ADMIN");
			return PLUGIN_HANDLED;
		}
		
		// Иначе этот же хочет его выключить
		remove_task(id + TASK_EDITOR);
		
		// Сохраняем стену, которую он редактировал
		if(editor_ent) {
			finish_edit(editor_ent);
		}
		
		// Пишем изменения в файл
		write_walls_to_file();
		
		// Он может быть не подключен, если вызов из client_disconnect
		if(is_bit(is_connected, id)) {
			client_print_color(id, id, "%L", id, "RUSH_EDITOR_SAVED_AND_EXIT");
		}
		
		// Отключаем кароч
		editor_enabled = 0;
		
		destroy_walls();
		
		set_pcvar_num(cvar_state_pointer, STATE_WAITING_FOR_PLAYERS_1ST);
	} else {
		// Запускаем редактор
		editor_enabled = id;
		editor_menu = EDITOR_MAIN_MENU;
		current_mode[0] = '^0';
		editor_ent = 0;
		
		spawn_walls();
		
		set_pcvar_num(cvar_state_pointer, STATE_EDITOR);
		
		task_editor_menu(id + TASK_EDITOR);
		set_task(1.0, "task_editor_menu", id + TASK_EDITOR, .flags="b");
	}	
	
	return PLUGIN_HANDLED;
}

public task_editor_menu(id) {
	id -= TASK_EDITOR;
	
	switch(editor_menu) {
		case(EDITOR_MAIN_MENU): {
			editor_main_menu(id);
		}
		
		case(EDITOR_WALL_PROP): {
			editor_prop_menu(id);
		}
	}
}

// Главное меню
stock editor_main_menu(id) {
	new menu_text[512], len;
	len = formatex(menu_text, charsmax(menu_text), "%L", id, "RUSH_EDITOR_HEADER");
	len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, "RUSH_EDITOR_CREATE");
	len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, "RUSH_EDITOR_DELETE");
	len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, "RUSH_EDITOR_EDIT");
	
	new mode_name[128];
	if(!current_mode[0]) {
		copy(mode_name, charsmax(mode_name), "RUSH_EDITOR_MODE_GENERAL");
	} else {
		TrieGetString(config_modes_translate, current_mode, mode_name, charsmax(mode_name));
	}
		
	len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, "RUSH_EDITOR_MODE", id, mode_name);
	len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, "RUSH_EDITOR_EXIT", id, mode_name);
	
	#if defined SHOW_COPYRIGHTS
		formatex(menu_text[len], charsmax(menu_text) - len, "^n^n\y%s v%s by %s", PLUGIN, VERSION, AUTHOR);
	#endif
	
	show_menu(id, MENU_KEY_0 | MENU_KEY_1 | MENU_KEY_2 | MENU_KEY_3 | MENU_KEY_4, menu_text, 2, "editor main menu");
}

// Кнопочка главного меню
public editor_main_menu_action(id, key) {
	switch(key) {
		case(0): { // Создать стену
		
			// Получаем позицию
			new Float:user_origin[3];
			entity_get_vector(id, EV_VEC_origin, user_origin);
			
			// Делаем строку новой рагульной стены
			new params[192];
			formatex(params, charsmax(params), "%.02f %.02f %.02f 0.0 0.0 0.0 -4.0 -32.0 -32.0 4.0 32.0 32.0 0.25", user_origin[0], user_origin[1], user_origin[2]);
			
			// Рождаем стену и начинаем ее редактировать
			editor_ent = create_wall(params, -1, current_mode);
			start_edit(editor_ent);
			
			editor_menu = EDITOR_WALL_PROP;
			editor_prop = EDITOR_PROP_ORIGIN;
			editor_step = EDITOR_STEP_1;
			
			task_editor_menu(id + TASK_EDITOR);
			return;
		}
		
		case(1): { // Удалить ближайшую стену
			// Ищем
			new ent = find_closest_wall(id);
			if(ent) {
				start_edit(ent); // Удаляет стену из конфига
				remove_entity(ent);
				client_print(id, print_center, "%L", id, "RUSH_EDITOR_WALLS_DELETED");
			} else {
				// Ничего не найдено
				client_print(id, print_center, "%L", id, "RUSH_EDITOR_WALLS_NOT_FOUND");
			}
		}
		
		case(2): { // Редактировать ближайшую стену
			new ent = find_closest_wall(id);
			if(ent) {
				// Редактируем
				start_edit(ent);
				editor_ent = ent;
				
				editor_menu = EDITOR_WALL_PROP;
				editor_prop = EDITOR_PROP_ORIGIN;
				editor_step = EDITOR_STEP_1;
				
				task_editor_menu(id + TASK_EDITOR);
			} else {
				// Ничего не найдено
				client_print(id, print_center, "%L", id, "RUSH_EDITOR_WALLS_NOT_FOUND");
			}
		}
		
		case(3): { // Смена режима редактора
			destroy_walls(); // Ибо спавнить нужно только стены нужного режима
			
			// Меняем мод
			if(!current_mode[0]) {
				ArrayGetString(config_modes, 0, current_mode, charsmax(current_mode));
			} else {
				new pos = ArrayFindString(config_modes, current_mode) + 1;
				if(pos == ArraySize(config_modes)) {
					current_mode[0] = '^0';
				} else {
					ArrayGetString(config_modes, pos, current_mode, charsmax(current_mode));
				}
			}
			
			// Спавним стены нужного режима
			spawn_walls();
		}
		
		case(9): { // Закрываем редактор
			cmd_editor(id);
			return;
		}
	}
	
	task_editor_menu(id + TASK_EDITOR);
}

// Прорисовка границ стены 
public wall_think(ent) {
	// Эту стену не редактируем?
	if(ent != editor_ent) {
		return;
	}
	
	new Float:mins[3], Float:maxs[3], Float:origin[3];
	
	entity_get_vector(ent, EV_VEC_origin, origin);
	entity_get_vector(ent, EV_VEC_mins, mins);
	entity_get_vector(ent, EV_VEC_maxs, maxs);

	engfunc(EngFunc_MessageBegin, MSG_BROADCAST, SVC_TEMPENTITY, origin, 0);
	write_byte(TE_BOX);
	engfunc(EngFunc_WriteCoord, (mins[0] + origin[0]));
	engfunc(EngFunc_WriteCoord, (mins[1] + origin[1]));
	engfunc(EngFunc_WriteCoord, (mins[2] + origin[2]));
	engfunc(EngFunc_WriteCoord, (maxs[0] + origin[0]));
	engfunc(EngFunc_WriteCoord, (maxs[1] + origin[1]));
	engfunc(EngFunc_WriteCoord, (maxs[2] + origin[2]));
	write_short(2);
	write_byte(255);
	write_byte(0);
	write_byte(0);
	message_end();

	entity_set_float(ent, EV_FL_nextthink, get_gametime() + 0.1);
}

// Поиск ближайшей стены
stock find_closest_wall(id) {
	new ent = -1, Float:best_distance = 9999.0, closest_ent, Float:player_origin[3], Float:wall_origin[3], Float:dist;
	entity_get_vector(id, EV_VEC_origin, player_origin);
	
	while((ent = find_ent_by_class(ent, "rush_wall"))) {
		entity_get_vector(ent, EV_VEC_origin, wall_origin);
		dist = get_distance_f(player_origin, wall_origin);
		
		if(dist < best_distance) {
			closest_ent = ent;
			best_distance = dist;
		}
	}
	
	return closest_ent;
}

// Подготовка стены к редактированию
stock start_edit(ent) {
	// Удобно, если свозь стену можно проходить
	entity_set_int(ent, EV_INT_solid, SOLID_NOT);
	
	// Получаем строку параметров стены, чтобы найти ее в массиве конфига и удалить
	new params[192], wall_mode[32], id;
	id = get_wall_prop(ent, params, charsmax(params), wall_mode, charsmax(wall_mode));
	
	// Мы еще ничего не редактировали?
	if(!editor_think) {
		editor_think = register_think("rush_wall", "wall_think");
	}
	
	// Рисуем границы через 0.1 сек
	entity_set_float(ent, EV_FL_nextthink, get_gametime() + 0.1);
	
	// Определяем в каком массиве у нас должна быть стена
	new Array:walls_array;
	if(wall_mode[0]) {
		if(TrieKeyExists(config_walls_by_modes, wall_mode)) {
			TrieGetCell(config_walls_by_modes, wall_mode, walls_array);
		} else {
			return;
		}
	} else {
		walls_array = config_walls;
	}

	// Удаляем стену из конфига, если она есть, потом добавим обратно, если нужно
	if(id != -1) {
		ArraySetString(walls_array, id, "");
	}
}

// Окончание редактирования стены
stock finish_edit(ent) {
	// Делаем твёрдой
	entity_set_int(ent, EV_INT_solid, SOLID_BBOX);
	
	// Получаем строку параметров стены
	new params[192], wall_mode[32];
	get_wall_prop(ent, params, charsmax(params), wall_mode, charsmax(wall_mode));
	
	// Пишем в массив конфигов
	if(!wall_mode[0]) {
		ArrayPushString(config_walls, params);
		entity_set_int(ent, EV_INT_iuser1, ArraySize(config_walls));
	} else {
		new Array:walls_array;
		if(TrieKeyExists(config_walls_by_modes, wall_mode)) {
			TrieGetCell(config_walls_by_modes, wall_mode, walls_array);
		} else {
			walls_array = ArrayCreate(512);
			TrieSetCell(config_walls_by_modes, wall_mode, walls_array);
		}
		ArrayPushString(walls_array, params);
		entity_set_int(ent, EV_INT_iuser1, ArraySize(walls_array));
	}
}

// Получение строки параметров стены
stock get_wall_prop(ent, params[], params_len, mode[], mode_len) {
	new Float:wall_origins[3], Float:wall_angles[3], Float:wall_mins[3], Float:wall_maxs[3], Float:scale;
	
	entity_get_vector(ent, EV_VEC_origin, wall_origins);
	entity_get_vector(ent, EV_VEC_angles, wall_angles);
	entity_get_vector(ent, EV_VEC_mins, wall_mins);
	entity_get_vector(ent, EV_VEC_maxs, wall_maxs);
	scale = entity_get_float(ent, EV_FL_scale);
	entity_get_string(ent, EV_SZ_noise1, mode, mode_len);
	
	// По-моему тут ебланит точность и вызывает баг с дублированием стены
	formatex(params, params_len, "%.02f %.02f %.02f %.02f %.02f %.02f %.02f %.02f %.02f %.02f %.02f %.02f %.02f", wall_origins[0], wall_origins[1], wall_origins[2], wall_angles[0], wall_angles[1], wall_angles[2], wall_mins[0], wall_mins[1], wall_mins[2], wall_maxs[0], wall_maxs[1], wall_maxs[2], scale);
	
	return entity_get_int(ent, EV_INT_iuser1);
}

// Меню редактирование конкретной стены
stock editor_prop_menu(id) {
	new menu_text[512], len, keys = MENU_KEY_0;
	len = formatex(menu_text, charsmax(menu_text), "%L", id, "RUSH_EDITOR_HEADER_PROP", editor_ent);
	
	switch(editor_prop) {
		case(EDITOR_PROP_ORIGIN): { // Расположение
			new Float:vec[3];
			entity_get_vector(editor_ent, EV_VEC_origin, vec);
			
			len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, "RUSH_EDITOR_PROP_ORIGIN_HEAD", vec[0], vec[1], vec[2]);
		}
		
		case(EDITOR_PROP_ANGLES): { // Углы спрайта
			new Float:vec[3];
			entity_get_vector(editor_ent, EV_VEC_angles, vec);
			
			len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, "RUSH_EDITOR_PROP_ANGLES_HEAD", vec[0], vec[1], vec[2]);
		}
		
		case(EDITOR_PROP_MINS): { // Mins
			new Float:vec[3];
			entity_get_vector(editor_ent, EV_VEC_mins, vec);
			
			len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, "RUSH_EDITOR_PROP_MINS_HEAD", vec[0], vec[1], vec[2]);
		}
		
		case(EDITOR_PROP_MAXS): { // Maxs
			new Float:vec[3];
			entity_get_vector(editor_ent, EV_VEC_maxs, vec);
			
			len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, "RUSH_EDITOR_PROP_MAXS_HEAD", vec[0], vec[1], vec[2]);
		}
		
		case(EDITOR_PROP_SCALE): { // Масштаб спрайта
			new Float:scale = entity_get_float(editor_ent, EV_FL_scale);
			
			len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, "RUSH_EDITOR_PROP_SCALE_HEAD", scale);
		}
	}
	
	// Немного разнные кноки для разных параметров
	switch(editor_prop) {
		case EDITOR_PROP_ORIGIN..EDITOR_PROP_MAXS: { // Расположение, углы, mins, maxs
			keys |= (MENU_KEY_1 | MENU_KEY_2 | MENU_KEY_3 | MENU_KEY_4 | MENU_KEY_5 | MENU_KEY_6);
			len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, "RUSH_EDITOR_XYZ");
		}
		
		case(EDITOR_PROP_SCALE): { // Маштаб
			keys |= (MENU_KEY_1 | MENU_KEY_2);
			len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, "RUSH_EDITOR_SCALEEDIT");
		}
		
		case(EDITOR_PROP_MODE): { // Режим
			keys |= MENU_KEY_1;
			
			new mode_name[128], wall_mode[32];
			entity_get_string(editor_ent, EV_SZ_noise1, wall_mode, charsmax(wall_mode));
			if(!wall_mode[0]) {
				copy(mode_name, charsmax(mode_name), "RUSH_EDITOR_MODE_GENERAL");
			} else {
				TrieGetString(config_modes_translate, wall_mode, mode_name, charsmax(mode_name));
			}
		
			len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, "RUSH_EDITOR_PROP_MODE", id, mode_name);
		}
	}
	
	// Смена параметров
	keys |= (MENU_KEY_7 | MENU_KEY_8);
	
	static const EDITOR_PROPS[][] = {
		"RUSH_PROP_ORIGIN",
		"RUSH_PROP_ANGLES",
		"RUSH_PROP_MINS",
		"RUSH_PROP_MAXS",
		"RUSH_PROP_SCALE",
		"RUSH_PROP_MODE"
	};
	
	len += formatex(menu_text[len], charsmax(menu_text) - len, "%L%L", id, "RUSH_EDITOR_STEP", EDITOR_STEPS[editor_step], id, "RUSH_EDITOR_PROP", id, EDITOR_PROPS[editor_prop]);
	
	// Выход
	len += formatex(menu_text[len], charsmax(menu_text) - len, "%L", id, "RUSH_EDITOR_EXIT");
	
	#if defined SHOW_COPYRIGHTS
		formatex(menu_text[len], charsmax(menu_text) - len, "^n^n\y%s v%s by %s", PLUGIN, VERSION, AUTHOR);
	#endif
	
	show_menu(id, keys, menu_text, 2, "editor prop menu");
}

// Кнопка редактора параметров стены
public editor_prop_menu_action(id, key) {
	switch(key) {
		case(9): { // Выход
		
			// Завершаем редактирование конкретной стены
			finish_edit(editor_ent);
			editor_ent = 0;
			
			editor_menu = EDITOR_MAIN_MENU;
			
			// На случай если в процессе был сменен режим для стены
			destroy_walls();
			spawn_walls();
		}
		
		case(7): { // Смена параметра
			if(++editor_prop == EDITOR_PROP_END) {
				editor_prop = EDITOR_PROP_ORIGIN;
			}
		}
		
		case(6): { // Смена шага редактирования
			if(++editor_step == EDITOR_STEP_END) {
				editor_step = EDITOR_STEP_001;
			}
		}
		
		default: {
			switch(editor_prop) {
				case(EDITOR_PROP_ORIGIN): { // Расположение
					new Float:vec[3];
					entity_get_vector(editor_ent, EV_VEC_origin, vec);
					editor_edit(vec, key);
					entity_set_vector(editor_ent, EV_VEC_origin, vec);
				}
				
				case(EDITOR_PROP_ANGLES): { // Углы
					new Float:vec[3];
					entity_get_vector(editor_ent, EV_VEC_angles, vec);
					editor_edit(vec, key);
					entity_set_vector(editor_ent, EV_VEC_angles, vec);
				}
				
				case(EDITOR_PROP_MINS): { // Mins
					new Float:vec[3], Float:vec2[3];
					entity_get_vector(editor_ent, EV_VEC_mins, vec);
					entity_get_vector(editor_ent, EV_VEC_maxs, vec2);
					editor_edit(vec, key);
					
					// Если этого не делать, то может упасть сервер
					vec[0] = floatmin(0.0, vec[0]);
					vec[1] = floatmin(0.0, vec[1]);
					vec[2] = floatmin(0.0, vec[2]);
					
					entity_set_size(editor_ent, vec, vec2);
				}
				
				case(EDITOR_PROP_MAXS): {
					new Float:vec[3], Float:vec2[3];
					entity_get_vector(editor_ent, EV_VEC_mins, vec2);
					entity_get_vector(editor_ent, EV_VEC_maxs, vec);
					editor_edit(vec, key);
					
					// Если этого не делать, то может упасть сервер
					vec[0] = floatmax(0.0, vec[0]);
					vec[1] = floatmax(0.0, vec[1]);
					vec[2] = floatmax(0.0, vec[2]);
					
					entity_set_size(editor_ent, vec2, vec);
				}
				
				case(EDITOR_PROP_SCALE): { // Масштаб
					new Float:scale = entity_get_float(editor_ent, EV_FL_scale);
					if(!key) {
						scale += EDITOR_STEPS[editor_step];
					} else {
						scale -= EDITOR_STEPS[editor_step];
					}
					entity_set_float(editor_ent, EV_FL_scale, scale);
				}
				
				case(EDITOR_PROP_MODE): { // Режим
					new wall_mode[32];
					entity_get_string(editor_ent, EV_SZ_noise1, wall_mode, charsmax(wall_mode));
					
					if(!wall_mode[0]) {
						ArrayGetString(config_modes, 0, wall_mode, charsmax(wall_mode));
					} else {
						new pos = ArrayFindString(config_modes, wall_mode) + 1;
						if(pos == ArraySize(config_modes)) {
							wall_mode[0] = '^0';
						} else {
							ArrayGetString(config_modes, pos, wall_mode, charsmax(wall_mode));
						}
					}
					entity_set_string(editor_ent, EV_SZ_noise1, wall_mode);
				}
			}
		}
	}
	
	task_editor_menu(id + TASK_EDITOR); // Переоткрываем меню
}

// Само изменение параметра X Y Z
stock editor_edit(Float:vec[3], key) {
	switch(key) {
		case(0): {
			vec[0] += EDITOR_STEPS[editor_step];
		}
		
		case(1): {
			vec[1] += EDITOR_STEPS[editor_step];
		}
		
		case(2): {
			vec[2] += EDITOR_STEPS[editor_step];
		}
		
		case(3): {
			vec[0] -= EDITOR_STEPS[editor_step];
		}
		
		case(4): {
			vec[1] -= EDITOR_STEPS[editor_step];
		}
		
		case(5): {
			vec[2] -= EDITOR_STEPS[editor_step];
		}
	}
}

// Пишем стены в файл конфига
stock write_walls_to_file() {
	// Запоминаем все, что идет в конфиге до секции [WALLS]
	new fp;
	if(!(fp = fopen(config_file, "r"))) {
		log_amx("Can't open for reading config file ^"%s^"", config_file);
		return;
	}
	
	new Array:lines_buffer = ArrayCreate(1024), buffer[1024];
	while(!feof(fp)) {
		fgets(fp, buffer, charsmax(buffer));
		
		ArrayPushString(lines_buffer, buffer);
		
		if(equal(buffer, "[WALLS]", 7)) {
			break;
		}
	}
	
	fclose(fp);
	
	// Переоткрываем файл для записи, очищая его
	if(!(fp = fopen(config_file, "w"))) {
		log_amx("Can't open for write config file ^"%s^"", config_file);
		return;
	}
	
	// Пишем все данные до секции [WALLS]
	new array_size = ArraySize(lines_buffer);
	for(new i; i < array_size; i++) {
		ArrayGetString(lines_buffer, i, buffer, charsmax(buffer));
		fprintf(fp, "%s", buffer);
	}
	ArrayDestroy(lines_buffer);
	
	// Пишем непосредственно наши стены
	array_size = ArraySize(config_walls);
	for(new i; i < array_size; i++) {
		ArrayGetString(config_walls, i, buffer, charsmax(buffer));
		if(!buffer[0]) {
			continue;
		}
		fprintf(fp, "^"%s^"^n", buffer);
	}
	
	new mode_name[32], modes_count = ArraySize(config_modes);
	for(new i; i < modes_count; i++) {
		ArrayGetString(config_modes, i, mode_name, charsmax(mode_name));
		
		if(TrieKeyExists(config_walls_by_modes, mode_name)) {
			new Array:walls_array;
			TrieGetCell(config_walls_by_modes, mode_name, walls_array);
			array_size = ArraySize(walls_array);
			for(new x; x < array_size; x++) {
				ArrayGetString(walls_array, x, buffer, charsmax(buffer));
				if(!buffer[0]) {
					continue;
				}
				fprintf(fp, "^"%s^"=^"%s^"^n", mode_name, buffer);
			}
		}
	}
	
	fclose(fp);
	
}

// [WALLS CONTROLLER]

// Расставляет стены непосредственно для нашего current_mode
stock spawn_walls() {
	new params[512], array_size = ArraySize(config_walls);
	
	// Сначала общие
	for(new i; i < array_size; i++) {
		ArrayGetString(config_walls, i, params, charsmax(params));
		create_wall(params, i);
	}
	
	// Затем для режима, если есть
	if(TrieKeyExists(config_walls_by_modes, current_mode)) {
		new Array:walls_array;
		TrieGetCell(config_walls_by_modes, current_mode, walls_array);
		array_size = ArraySize(walls_array);
		for(new i; i < array_size; i++) {
			ArrayGetString(walls_array, i, params, charsmax(params));
			create_wall(params, i, current_mode);
		}
	}
}

// Убирает активные стены
stock destroy_walls() {
	new array_size = ArraySize(active_walls), ent;
	for(new i; i < array_size; i++) {
		ent = ArrayGetCell(active_walls, i);
		
		if(is_valid_ent(ent)) {
			remove_entity(ent);
		}
	}
	ArrayClear(active_walls);
}

// Ставит стену с конкретными параметрами
stock create_wall(const params[], id, const mode[] = "") {
	new ent = create_entity("func_wall");
	
	if(!ent) {
		log_amx("Cant create wall entity!");
		return 0;
	}
	
	new any:wall_params[wall_struct], arg[32], pos, param;
	
	// Парсим параметры в массив
	// Amx Mod X 1.8.3
	while((pos = argparse(params, pos, arg, charsmax(arg))) != -1) {
		wall_params[wall_struct:param++] = str_to_float(arg);
	}

	entity_set_string(ent, EV_SZ_classname, "rush_wall");
	entity_set_model(ent, "sprites/rush_wall.spr");
	
	// Чтобы не двигалась
	entity_set_int(ent, EV_INT_movetype, MOVETYPE_FLY);
	
	new Float:arr1[3], Float:arr2[3];
	
	// Расположение
	arr1[0] = wall_params[ORIGIN_X];
	arr1[1] = wall_params[ORIGIN_Y],
	arr1[2] = wall_params[ORIGIN_Z];
	entity_set_vector(ent, EV_VEC_origin, arr1);
	
	// Размеры
	arr1[0] = wall_params[MINS_X];
	arr1[1] = wall_params[MINS_Y],
	arr1[2] = wall_params[MINS_Z];
	arr2[0] = wall_params[MAXS_X];
	arr2[1] = wall_params[MAXS_Y],
	arr2[2] = wall_params[MAXS_Z];
	entity_set_size(ent, arr1, arr2);
	
	// Масштаб спрайта
	entity_set_float(ent, EV_FL_scale, wall_params[SCALE]);
	
	// Углы
	arr1[0] = wall_params[ANGLES_X];
	arr1[1] = wall_params[ANGLES_Y],
	arr1[2] = wall_params[ANGLES_Z];
	entity_set_vector(ent, EV_VEC_angles, arr1);
	
	// Делаем твердой
	entity_set_int(ent, EV_INT_solid, SOLID_BBOX);

	// Фрейм спрайта + немного подсвечиваем
	entity_set_float(ent,EV_FL_frame, 1.0);
	entity_set_int(ent, EV_INT_rendermode, kRenderTransAdd);
	entity_set_float(ent, EV_FL_renderamt, 175.0);
	
	// Сохраняем сюда id режима (скажем спасибки VALVE, что оставили нам пустые pev)
	entity_set_string(ent, EV_SZ_noise1, mode);
	
	// Сохраняем сюда id в массиве (скажем спасибки VALVE, что оставили нам пустые pev)
	entity_set_int(ent, EV_INT_iuser1, id);
	
	// Запоминаем, что стена активна
	ArrayPushCell(active_walls, ent);
	
	return ent;
}

// Оружие коснулось стены, бросаем его под стену
public wall_touch(ent, id) {
	new Float:velocity[3];
	get_global_vector(GL_v_forward, velocity);

	velocity[0] = -velocity[0] * 15.0;
	velocity[1] = -velocity[1] * 15.0;
	velocity[2] = -velocity[2] * 15.0;

	entity_set_vector(ent, EV_VEC_velocity, velocity);
}

// [AFK CONTROLLER]

// Цикл проверки AFK
public afk_check() {
	if(!cvar_afk_time) {
		return;
	}
	
	for(new id = 1; id <= MaxClients; id++) {
		if(!is_bit(is_alive, id) || !is_bit(afk_origins_saved, id)) {
			continue;
		}
		
		new origin[3];
		get_user_origin(id, origin, 0);
		
		// Стоит на месте
		if(origin[0] == afk_origins[id][0] && origin[1] == afk_origins[id][1] && origin[2] == afk_origins[id][2]) {
			afk_time[id]++;
			
			if(afk_time[id] == cvar_afk_time) { // Кик
				svc_disconnect(id, "%L", id, "RUSH_AFK_KICK_REASON");
			
				new name[MAX_NAME_LENGTH];
				get_user_name(id, name, charsmax(name));
				
				// Цикл, чтобы персонально для каждого подобрался язык
				for(new x = 1; x <= MaxClients; x++) {
					if(!is_bit(is_connected, x)) {
						continue;
					}
					
					client_print_color(x, id, "%L", x, "RUSH_AFK_KICK_MESSAGE", name);
				}
			} else if(cvar_afk_bomb_time && afk_bomb_carrier == id && afk_time[id] == cvar_afk_bomb_time) { // Выбрасываем
				engclient_cmd(id, "drop", "weapon_c4");
								
				// Цикл, чтобы персонально для каждого подобрался язык
				for(new x = 1; x <= MaxClients; x++) {
					if(!is_bit(is_connected, x)) {
						continue;
					}
					
					client_print_color(x, id, "%L", x, "RUSH_AFK_BOMB");
				}
			} else {
				// Пишем варнинг каждые 5 секунд., если до кика осталось 30 и меньше сек.
				new afk_left = cvar_afk_time - afk_time[id];
				if(afk_left <= 30 && !(afk_left % 5)) {
					client_print_color(id, id, "%L", id, "RUSH_AFK_LEFT", afk_left);
				}
			}
		} else {
			for(new i; i < 3; i++) {
				afk_origins[id][i] = origin[i];
			}
			
			afk_time[id] = 0;
		}
	}
}

// Определяем владельца бомбы
public afk_bomb() {
	new arg[64], message[64], name[MAX_NAME_LENGTH], userid, id; 
    
	read_logargv(0, arg, charsmax(arg));
	read_logargv(2, message, charsmax(message));
    
	parse_loguser(arg, name, 31, userid);
	id = find_player("k", userid);
    
	if(equali(message, "Spawned_With_The_Bomb") || equali(message, "Got_The_Bomb")) { // Кто-то взял бомбу
		afk_bomb_carrier = id; 
	} else if(equali(message, "Planted_The_Bomb") || equali(message, "Dropped_The_Bomb")) { // Кто-то потерял бомбу
		afk_bomb_carrier = 0;
    }
}

// Берем позицию игрока после возрождения
public afk_get_origins(id) {
	if(!is_bit(is_alive, id)) {
		return;
	}
	
	get_user_origin(id, afk_origins[id], 0);
	add_bit(afk_origins_saved, id);
}

// [RESTRICTION CONSTROLLER]

// Команды добавления запрета на оружме
public cmd_ter_restrict() {
	new args[128];
	read_args(args, charsmax(args));
	
	add_to_restriction(CS_TEAM_T, args);
	
	return PLUGIN_HANDLED;
}

public cmd_ct_restrict() {
	new args[128];
	read_args(args, charsmax(args));
	
	add_to_restriction(CS_TEAM_CT, args);

	return PLUGIN_HANDLED;
}

// Парсим строку в битсумму запрещенного оружия
stock add_to_restriction(any:team, args[]) {
	remove_quotes(args);
	trim(args);
	
	restrictions[team] = 0;
	
	if(args[0]) {
		new arg[32], pos;
		
		// Amx Mod X 1.8.3
		while((pos = argparse(args, pos, arg, charsmax(arg))) != -1) {
			restrictions[team] |= (1 << (str_to_num(arg) - 1));
		}
	}
}

// Игрок пытается купить оружие
// Amx Mod X 1.8.3
public CS_OnBuy(id, item) {
	if(item > 32 && item != CSI_SHIELDGUN) {
		return PLUGIN_CONTINUE;
	}
	
	if(item == CSI_VEST || item == CSI_VESTHELM) {
		return check_restriction(id, CSI_VEST);
	} else if(item == CSI_SHIELDGUN) {
		return check_restriction(id, CSI_VESTHELM);
	}
	
	return check_restriction(id, item);
}

// Проверяем есть ли оно в списке запрещенных
stock check_restriction(id, item) {
	if(restrictions[players_team[id]] & (1 << (item - 1))) {
		client_print(id, print_center, "%L", id, "RUSH_ITEM_RESTRICTED");
		return PLUGIN_HANDLED;
	}
	
	return PLUGIN_CONTINUE;
}

// [FINITA LA COMEDIA]